The Synthesis ToolKit in C++ (STK)

Home Information Classes Download Usage Mail List Requirements Links FAQ Tutorial

# stk::FreeVerb Class Reference

Jezar at Dreampoint's FreeVerb, implemented in STK. More...

`#include <FreeVerb.h>`

Inheritance diagram for stk::FreeVerb:

List of all members.

## Public Member Functions
| FreeVerb ()
| FreeVerb Constructor.
| ~FreeVerb ()
| Destructor.
void | setEffectMix (StkFloat mix)
| Set the effect mix [0 = mostly dry, 1 = mostly wet].
void | setRoomSize (StkFloat value)
| Set the room size (comb filter feedback gain) parameter [0,1].
StkFloat | getRoomSize (void)
| Get the room size (comb filter feedback gain) parameter.
void | setDamping (StkFloat value)
| Set the damping parameter [0=low damping, 1=higher damping].
StkFloat | getDamping (void)
| Get the damping parameter.
void | setWidth (StkFloat value)
| Set the width (left-right mixing) parameter [0,1].
StkFloat | getWidth (void)
| Get the width (left-right mixing) parameter.
void | setMode (bool isFrozen)
| Set the mode [frozen = 1, unfrozen = 0].
StkFloat | getMode (void)
| Get the current freeze mode [frozen = 1, unfrozen = 0].
void | clear (void)
| Clears delay lines, etc.
StkFloat | lastOut (unsigned int channel=0)
| Return the specified channel value of the last computed stereo frame.
StkFloat | tick (StkFloat inputL, StkFloat inputR=0.0, unsigned int channel=0)
| Input one or two samples to the effect and return the specified `channel` value of the computed stereo frame.
StkFrames & | tick (StkFrames &frames, unsigned int channel=0)
| Take two channels of the StkFrames object as inputs to the effect and replace with stereo outputs.
StkFrames & | tick (StkFrames &iFrames, StkFrames &oFrames, unsigned int iChannel=0, unsigned int oChannel=0)
| Take one or two channels of the `iFrames` object as inputs to the effect and write stereo outputs to the `oFrames` object.
## Protected Member Functions
void | update (void)
| Update interdependent parameters.

## Detailed Description

Jezar at Dreampoint's FreeVerb, implemented in STK.

Freeverb is a free and open-source Schroeder reverberator originally implemented in C++. The parameters of the reverberation model are exceptionally well tuned. FreeVerb uses 8 lowpass-feedback-comb-filters in parallel, followed by 4 Schroeder allpass filters in series. The input signal can be either mono or stereo, and the output signal is stereo. The delay lengths are optimized for a sample rate of 44100 Hz.

Ported to STK by Gregory Burlet, 2012.

## Constructor & Destructor Documentation

stk::FreeVerb::FreeVerb | ( |  | ) |

FreeVerb Constructor.

Initializes the effect with default parameters. Note that these defaults are slightly different than those in the original implementation of FreeVerb [Effect Mix: 0.75; Room Size: 0.75; Damping: 0.25; Width: 1.0; Mode: freeze mode off].

## Member Function Documentation

StkFloat stk::FreeVerb::lastOut | ( | unsigned int | channel = `0` | ) | `[inline]`

Return the specified channel value of the last computed stereo frame.

Use the lastFrame() function to get both values of the last computed stereo frame. The `channel` argument must be 0 or 1 (the first channel is specified by 0). However, range checking is only performed if _STK_DEBUG_ is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

    00166 {
    00167 #if defined(_STK_DEBUG_)
    00168   if ( channel > 1 ) {
    00169     oStream_ << "FreeVerb::lastOut(): channel argument must be less than 2!";
    00170     handleError( StkError::FUNCTION_ARGUMENT );
    00171   }
    00172 #endif
    00173
    00174   return lastFrame_[channel];
    00175 }

StkFloat stk::FreeVerb::tick | ( | StkFloat | inputL,
|  | StkFloat | inputR = `0.0`,
|  | unsigned int | channel = `0` |
| ) |  |  | `[inline]`

Input one or two samples to the effect and return the specified `channel` value of the computed stereo frame.

Use the lastFrame() function to get both values of the computed stereo output frame. The `channel` argument must be 0 or 1 (the first channel is specified by 0). However, range checking is only performed if _STK_DEBUG_ is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

    00178 {
    00179 #if defined(_STK_DEBUG_)
    00180   if ( channel > 1 ) {
    00181     oStream_ << "FreeVerb::tick(): channel argument must be less than 2!";
    00182     handleError(StkError::FUNCTION_ARGUMENT);
    00183   }
    00184 #endif
    00185
    00186   if ( !inputR ) {
    00187     inputR = inputL;
    00188   }
    00189
    00190   StkFloat fInput = (inputL + inputR) * gain_;
    00191   StkFloat outL = 0.0;
    00192   StkFloat outR = 0.0;
    00193
    00194   // Parallel LBCF filters
    00195   for ( int i = 0; i < nCombs; i++ ) {
    00196     // Left channel
    00197     //StkFloat yn = fInput + (roomSize_ * FreeVerb::undenormalize(combLPL_[i].tick(FreeVerb::undenormalize(combDelayL_[i].nextOut()))));
    00198     StkFloat yn = fInput + (roomSize_ * combLPL_[i].tick( combDelayL_[i].nextOut() ) );
    00199     combDelayL_[i].tick(yn);
    00200     outL += yn;
    00201
    00202     // Right channel
    00203     //yn = fInput + (roomSize_ * FreeVerb::undenormalize(combLPR_[i].tick(FreeVerb::undenormalize(combDelayR_[i].nextOut()))));
    00204     yn = fInput + (roomSize_ * combLPR_[i].tick( combDelayR_[i].nextOut() ) );
    00205     combDelayR_[i].tick(yn);
    00206     outR += yn;
    00207   }
    00208
    00209   // Series allpass filters
    00210   for ( int i = 0; i < nAllpasses; i++ ) {
    00211     // Left channel
    00212     //StkFloat vn_m = FreeVerb::undenormalize(allPassDelayL_[i].nextOut());
    00213     StkFloat vn_m = allPassDelayL_[i].nextOut();
    00214     StkFloat vn = outL + (g_ * vn_m);
    00215     allPassDelayL_[i].tick(vn);
    00216
    00217     // calculate output
    00218     outL = -vn + (1.0 + g_)*vn_m;
    00219
    00220     // Right channel
    00221     //vn_m = FreeVerb::undenormalize(allPassDelayR_[i].nextOut());
    00222     vn_m = allPassDelayR_[i].nextOut();
    00223     vn = outR + (g_ * vn_m);
    00224     allPassDelayR_[i].tick(vn);
    00225
    00226     // calculate output
    00227     outR = -vn + (1.0 + g_)*vn_m;
    00228   }
    00229
    00230   // Mix output
    00231   lastFrame_[0] = outL*wet1_ + outR*wet2_ + inputL*dry_;
    00232   lastFrame_[1] = outR*wet1_ + outL*wet2_ + inputR*dry_;
    00233
    00234   /*
    00235   // Hard limiter ... there's not much else we can do at this point
    00236   if ( lastFrame_[0] >= 1.0 ) {
    00237     lastFrame_[0] = 0.9999;
    00238   }
    00239   if ( lastFrame_[0] <= -1.0 ) {
    00240     lastFrame_[0] = -0.9999;
    00241   }
    00242   if ( lastFrame_[1] >= 1.0 ) {
    00243     lastFrame_[1] = 0.9999;
    00244   }
    00245   if ( lastFrame_[1] <= -1.0 ) {
    00246     lastFrame_[1] = -0.9999;
    00247   }
    00248   */
    00249
    00250   return lastFrame_[channel];
    00251 }

StkFrames& stk::FreeVerb::tick | ( | StkFrames & | frames,
|  | unsigned int | channel = `0` |
| ) |  |  |

Take two channels of the StkFrames object as inputs to the effect and replace with stereo outputs.

The StkFrames argument reference is returned. The stereo inputs are taken from (and written back to) the StkFrames argument starting at the specified `channel`. Therefore, the `channel` argument must be less than ( channels() - 1 ) of the StkFrames argument (the first channel is specified by 0). However, range checking is only performed if _STK_DEBUG_ is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

StkFrames& stk::FreeVerb::tick | ( | StkFrames & | iFrames,
|  | StkFrames & | oFrames,
|  | unsigned int | iChannel = `0`,
|  | unsigned int | oChannel = `0` |
| ) |  |  |

Take one or two channels of the `iFrames` object as inputs to the effect and write stereo outputs to the `oFrames` object.

The `iFrames` object reference is returned. The `iChannel` argument must be less than the number of channels in the `iFrames` argument (the first channel is specified by 0). If more than one channel of data exists in `iFrames` starting from `iChannel`, stereo data is input to the effect. The `oChannel` argument must be less than ( channels() - 1 ) of the `oFrames` argument. However, range checking is only performed if _STK_DEBUG_ is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

The documentation for this class was generated from the following file:

- FreeVerb.h

The Synthesis ToolKit in C++ (STK)
©1995-2012 Perry R. Cook and Gary P. Scavone. All Rights Reserved.